/*
 * Created on 24.03.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.util.Vector;

import javax.swing.AbstractListModel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.ListCellRenderer;
import javax.swing.WindowConstants;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class JListTest extends JFrame {
    private static final String[] WDAYS =
        { "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag", "Sonntag" };

    JList list1, list2, list3, list4;

    public JListTest() {
        super("JList");
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE); 
        Container cp = getContentPane();
        cp.setLayout(new FlowLayout());
        list1 = new JList(new IntListModel(1000000));
        list1.addListSelectionListener( new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				System.out.println("List1 selection changed " + e.getFirstIndex() + 
						" to " + e.getLastIndex() + " - selected: " +
						selectedToString(list1.getSelectedIndices())); 		
			}
        });
		JScrollPane scrollPane = new JScrollPane(list1);
		scrollPane.setMinimumSize(new Dimension(30, 100)); 
        cp.add(scrollPane);
        
        list2 = new JList(WDAYS); 
        list2.addListSelectionListener( new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				System.out.println("List2 selection changed " + e.getFirstIndex() + 
						" to " + e.getLastIndex() + " - selected: " +
						selectedToString(list2.getSelectedIndices())); 
				for (int i: list2.getSelectedIndices()) {
					System.out.println(" --> " + list2.getModel().getElementAt(i)); 
				}
			}
        });
		scrollPane = new JScrollPane(list2);
		scrollPane.setMinimumSize(new Dimension(30, 100)); 
        cp.add(scrollPane);
        
        Vector v = new Vector(); 
        v.add("gestern"); v.add("heute"); v.add("morgen"); 
        list3 = new JList(v); 
        list3.addListSelectionListener( new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				System.out.println("List3 selection changed from " + e.getFirstIndex() + 
						" to " + e.getLastIndex() + " - selected: " +
						selectedToString(list3.getSelectedIndices())); 		
			}
        });
		scrollPane = new JScrollPane(list3);
		scrollPane.setMinimumSize(new Dimension(30, 100)); 
        cp.add(scrollPane);
       
        Font[] fonts = new Font[] { 
        		new Font("Serif", Font.PLAIN, 16), 
        		new Font("SansSerif", Font.PLAIN, 16), 
        		new Font("Monospaced", Font.PLAIN, 16),
        		new Font("Serif", Font.BOLD, 16), 
        		new Font("SansSerif", Font.BOLD, 16), 
        		new Font("Monospaced", Font.BOLD, 16),
        		new Font("Serif", Font.ITALIC, 16), 
        		new Font("SansSerif", Font.ITALIC, 16), 
        		new Font("Monospaced", Font.ITALIC, 16)
        }; 
        list4 = new JList(fonts); 
        list4.addListSelectionListener( new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				System.out.println("List4 selection changed " + e.getFirstIndex() + 
						" to " + e.getLastIndex() + " - selected: " +
						selectedToString(list4.getSelectedIndices())); 		
			}
        });
        list4.setCellRenderer(new FontCellRenderer()); 
		scrollPane = new JScrollPane(list4);
		scrollPane.setMinimumSize(new Dimension(30, 100)); 
        cp.add(scrollPane);
       
    }

    public static void main(String[] args) {
        JListTest frame = new JListTest();
        frame.setLocation(100, 100);
        frame.setSize(500, 400);
        frame.setVisible(true);
    }

	String selectedToString(int[] selectedIndices) {
		StringBuffer b = new StringBuffer();
		b.append("["); 
		for (int i: selectedIndices) {
			b.append(i); 
			b.append(" ");
		}
		b.deleteCharAt(b.length()-1); 
		b.append("]"); 
		return b.toString(); 
	}
}

class IntListModel extends AbstractListModel {
    public IntListModel(int n) {
   		this.n = n; 
    }

    public int getSize() {
        return n; 
    }

    public Object getElementAt(int i) {
        return new Integer(i); 
    }
    private int n; 

}

class FontCellRenderer extends JLabel implements ListCellRenderer {
    public FontCellRenderer() {
        setOpaque(true);    // must do this for background to show up
    }

    public Component getListCellRendererComponent(
            JList list, Object value, int index, boolean isSelected,
            boolean cellHasFocus) {
        	if (isSelected) {
	    setForeground(list.getSelectionForeground());
	    setBackground(list.getSelectionBackground());
	} else {
	    setForeground(list.getForeground());
	    setBackground(list.getBackground());
	}
         Font font = (Font) value;
         setFont(font);
         setText(font.getFamily());
         return this;
    }
    
}
